# Contributing to Elm

Thanks helping with the development of Elm! This document describes the basic
standards for opening pull requests and making the review process as smooth as
possible.


## Expectations

- Pull requests are reviewed in [batches](https://github.com/elm/expectations/blob/master/batching.md), so it can take some time to get a response.
- Smaller pull requests are easier to review. To fix nine typos, nine specific issues will always go faster than one big one. Learn why [here](https://github.com/elm/expectations/blob/master/small-pull-requests.md).
- Reviewers may not know as much as you about certain situations, so add links to supporting evidence for important claims, especially regarding standards for CSS, HTTP, URI, etc.

Finally, please be patient with the core team. They are trying their best with limited resources!


## Style Guide

  * Haskell &mdash; conform to [these guidelines][haskell]
  * JavaScript &mdash; use [Google's JS style guide][js]

[haskell]: https://gist.github.com/evancz/0a1f3717c92fe71702be
[js]: https://google.github.io/styleguide/javascriptguide.xml


## Branches

[The master branch][master] is the home of the next release of the compiler
so new features and improvements get merged there. Most pull requests
should target this branch!

[master]: http://github.com/elm-lang/elm/tree/master


## Licensing

Nothing extra to do for this. The default on GitHub described [here](https://docs.github.com/en/github/site-policy/github-terms-of-service#6-contributions-under-repository-license) is that:

> Whenever you add Content to a repository containing notice of a license, you license that Content under the same terms, and you agree that you have the right to license that Content under those terms. If you have a separate agreement to license that Content under different terms, such as a contributor license agreement, that agreement will supersede.


